//+------------------------------------------------------------------+
//|                                      CloseSpecificMagicNo EA.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters

extern string    Explanation1="After Above entered amount of Profit is Reached cumulatively in Orders with same magic Number, EA will close them all.";
extern int       MagicNumber=1000;
extern int       Slippage=3;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
    int ProfitTarget=AccountBalance()*0.002;
    double dblProfit=0;
    int POS=0;
    bool boolTerm=false;
    while(boolTerm==false)
      {
       if(OrderSelect(POS,SELECT_BY_POS))
         {
         if(OrderMagicNumber()==MagicNumber) dblProfit=dblProfit+OrderProfit();
         POS++;
         }
        else
        boolTerm=true;
      }
   if (dblProfit>= ProfitTarget)
   {
    for(int i=OrdersTotal()-1;i>=0;i--)
       {
       OrderSelect(i, SELECT_BY_POS);
       if(OrderMagicNumber()==MagicNumber)
       {
       int type   = OrderType();
              
       bool result = false;
              
       switch(type)
          {
          //Close opened long positions
          case OP_BUY  : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),Slippage,Red);
                         break;
               
          //Close opened short positions
          case OP_SELL : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),Slippage,LimeGreen);
          }
          
       if(result == false)
          {
            Sleep(0);
          }  
        }
      }  
      Print ("Profit Target For MagicNumber based Trades Reached & They have been Closed");
      return(0);
   }  
   
     Comment ("AccountBalance: $",AccountBalance(),"\n",
              "Account Equity: $",AccountEquity(),"\n",
              "Profit Target MagicNo. Based Trades: $",ProfitTarget,"\n",
              "Current Profit MagicNo. Based Trades: $",dblProfit,"\n");

  return(0);
}
        




//+------------------------------------------------------------------+

